#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 3
#property indicator_width2 3
#property indicator_maximum 1.0
#property indicator_minimum 0
//---- input parameters
extern int    Length =8;       // Bollinger Bands Period
extern double Deviation =1.00;    // Deviation was 2
extern double MoneyRisk =1.00; // Offset Factor
extern int    SignalMode =1;       // Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals; 3-no Signals;
extern int    Line=1;         // Display line mode: 0-no,1-yes  
extern int    Nbars=1500;
extern bool   AlertSoundON=false;
extern int TimeFrame        = 0;
extern string     TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-currentTF";
extern int Lb = 8;
double ssl[],sslo[],Hld,Hlv;
#property indicator_separate_window
string IndicatorFileName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,ssl);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,sslo);
   SetIndexStyle(1,DRAW_HISTOGRAM);

   
           switch(TimeFrame)
   {
      case 1: string TimeFrameStr = "M1" ;  break;
      case 5     :   TimeFrameStr = "M5" ;  break;
      case 15    :   TimeFrameStr = "M15";  break;
      case 30    :   TimeFrameStr = "M30";  break;
      case 60    :   TimeFrameStr = "H1" ;  break;
      case 240   :   TimeFrameStr = "H4" ;  break;
      case 1440  :   TimeFrameStr = "D1" ;  break;
      case 10080 :   TimeFrameStr = "W1" ;  break;
      case 43200 :   TimeFrameStr = "MN1";  break;
      default :      TimeFrameStr = "TF0";
   }


      IndicatorFileName = WindowExpertName();
   if (TimeFrame<Period()) TimeFrame=Period();

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  counted_bars=IndicatorCounted();
   int  i,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
         limit=Bars-counted_bars;
 

   if (TimeFrame != Period())
   {
      datetime TimeArray[];
         limit = MathMax(limit,TimeFrame/Period());
         ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
         
         
         for(i=0,int y=0; i<limit; i++)
         {
            if(Time[i]<TimeArray[y]) y++;
            //iCustom(NULL,TimeFrame,IndicatorFileName,Length,Deviation,MoneyRisk,SignalMode,Line,Nbars,AlertSoundON,0,y);
            ssl[i]   = iCustom(NULL,TimeFrame,"BBands_Stop_v1",Length,Deviation,MoneyRisk,SignalMode,Line,Nbars,AlertSoundON,0,y);
            sslo[i]   = iCustom(NULL,TimeFrame,"BBands_Stop_v1",Length,Deviation,MoneyRisk,SignalMode,Line,Nbars,AlertSoundON,1,y);
         }
      return(0);         
   }

//----
   for(i=Bars-Lb;i>=0;i--)
   {
      if(Close[i]>iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_UPPER,i))
      Hld = 1;
      else 
      {
       if(Close[i]<iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_LOWER,i))  
       Hld = -1;
       else
       Hld = 0;
      }
      
      if(Hld!=0)
      Hlv = Hld;
            
      if(Hlv == -1)
      ssl[i] = iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_UPPER,i+1);
      else
      sslo[i] = iBands(NULL,0,Length,Deviation,0,PRICE_CLOSE,MODE_LOWER,i+1);
   }
  

//----
   return(0);
  }
//+------------------------------------------------------------------+